#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>

PSP_MODULE_INFO("shiptest", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
extern unsigned char spr_start[]; // テクスチャ参照
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
#define CHR_COUNT 256 // スプライト最大数256を指定

// 描画用Vertex構造体
typedef struct Vertex{
	unsigned short u, v;
	unsigned short color;
	short x, y, z;
}Vertex;
struct Vertex* vertices;

// テクスチャ割り当てをプリプロセッサで定義
#define MY_SHIP 0

// 自機用パラメータ定義
unsigned int m_iShip_x,m_iShip_y;

// 変数初期化自作関数
void MyInitParam(){
	m_iShip_x=32; m_iShip_y=120;
}

// gu初期化自作関数
void MyInitGu(){
	sceGuInit(); sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_4444, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x44000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuEnable(GU_TEXTURE_2D);
	// テクスチャデータのセット
	sceGuTexMode(GU_PSM_4444, 0, 0, GU_FALSE);
	sceGuTexImage(0, 256, 256, 256, spr_start);
	sceGuTexFunc(GU_TFX_REPLACE, GU_TCC_RGBA);
	sceGuTexFilter(GU_NEAREST, GU_NEAREST);
	// 設定完了
	sceGuFinish(); sceGuSync(0, GU_SYNC_FINISH);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	// ディスプレイリストからメモリ割り当て(CHR_COUNT利用)
	vertices = (struct Vertex*)sceGuGetMemory(2*CHR_COUNT* sizeof(struct Vertex));
}

// 自機パラメータ制御 vertices[0-1]利用
void MyShip(){
	static int iMyShipAnime=0; // 8フレームに一度ブリンクさせる変数
	// テクスチャの割り当てやアニメーションを定義
	vertices[MY_SHIP  ].x = m_iShip_x;
	vertices[MY_SHIP+1].x = m_iShip_x+32;
	vertices[MY_SHIP  ].y = m_iShip_y;
	vertices[MY_SHIP+1].y = m_iShip_y+16;
	iMyShipAnime++;
	if(iMyShipAnime%8==0){
		vertices[0].u = 0;	vertices[0].v = 0;
		vertices[1].u = 32;	vertices[1].v = 16;
	}else{
		vertices[0].u = 32;	vertices[0].v = 0;
		vertices[1].u = 64;	vertices[1].v = 16;
	}
}

// メインルーチン
int main() {
	MyInitGu();		// gu初期化コール
	MyInitParam();	// 変数初期化コール
	while(1){
		sceGuStart(GU_DIRECT,list);
		sceGuClear(GU_COLOR_BUFFER_BIT); // 毎回描画クリア
		// 自機制御関数コール
		MyShip();
		// ループ末尾で描画処理を実行
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
